//
//  ViewController.swift
//  clipPhotoDemo
//
//  Created by zhoujianfeng on 16/6/10.
//  Copyright © 2016年 zhoujianfeng. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet weak var imageView: UIImageView!
    private var startPoint = CGPointZero
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // 给当前控制器view添加一个pan手势
        let panGesture = UIPanGestureRecognizer(target: self, action: #selector(didPan(_:)))
        view.addGestureRecognizer(panGesture)
    }
    
    @objc private func didPan(pan: UIPanGestureRecognizer) {
        
        let endPoint = pan.locationInView(view)
        let clipRect = CGRect(origin: startPoint, size: CGSize(width: endPoint.x - startPoint.x, height: endPoint.y - startPoint.y))
        
        if pan.state == .Began {
            startPoint = pan.locationInView(view)
        } else if pan.state == .Changed {
            clipRectView.frame = clipRect
        } else if pan.state == .Ended {
            
            // 开启位图上下文，并裁剪指定区域
            UIGraphicsBeginImageContextWithOptions(imageView.bounds.size, false, 0)
            let ctx = UIGraphicsGetCurrentContext()!
            let rectPath = UIBezierPath(rect: clipRect)
            rectPath.addClip()
            imageView.layer.renderInContext(ctx)
            let image = UIGraphicsGetImageFromCurrentImageContext()
            UIGraphicsEndImageContext()
            
            // 再次开启位图上下文，绘制裁剪后的图片
            UIGraphicsBeginImageContextWithOptions(clipRect.size, false, 0)
            image.drawAtPoint(CGPoint(x: -startPoint.x, y: -startPoint.y))
            let newImage = UIGraphicsGetImageFromCurrentImageContext()
            UIGraphicsEndImageContext()
            
            imageView.image = newImage
            clipRectView.frame = CGRectZero
        }
    }
    
    /// 裁剪区域黑色透明遮罩
    private lazy var clipRectView: UIView = {
        let clipRectView = UIView()
        clipRectView.backgroundColor = UIColor(white: 0, alpha: 0.5)
        self.view.addSubview(clipRectView)
        return clipRectView
    }()

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

